#pragma once

#include <QMainWindow>
#include <vector>

#include "../ui/ui_menu.h"

class Project;

class Menu : public QMainWindow, private Ui::Menu
{
   Q_OBJECT

public:
   explicit Menu(QWidget *parent = nullptr);
   ~Menu();

public slots:
   void mapNew();
   void mapOpen();
   void openAbout();
   void openMapProperties();
   void updateActions();

protected:
   void closeEvent(QCloseEvent *event) override;
   void openLicense(QWidget *parent);

private:
   Project *activeProject() const;
   QMdiSubWindow *activeSubWindow() const;
   void addProject(Project *proj);
};

// EOF
